package org.dromara.elevator.service.impl;

import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.EFunctionInfo;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.EHouseInfoBo;
import org.dromara.elevator.domain.vo.EHouseInfoVo;
import org.dromara.elevator.domain.EHouseInfo;
import org.dromara.elevator.mapper.EHouseInfoMapper;
import org.dromara.elevator.service.IEHouseInfoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 小区基础信息;Service业务层处理
 *
 * @author zy
 * @date 2024-07-26
 */
@RequiredArgsConstructor
@Service
public class EHouseInfoServiceImpl implements IEHouseInfoService {

    private final EHouseInfoMapper baseMapper;

    /**
     * 查询小区基础信息;
     *
     * @param id 主键
     * @return 小区基础信息;
     */
    @Override
    public EHouseInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询小区基础信息;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 小区基础信息;分页列表
     */
    @Override
    public TableDataInfo<EHouseInfoVo> queryPageList(EHouseInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<EHouseInfo> lqw = buildQueryWrapper(bo);
        Page<EHouseInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的小区基础信息;列表
     *
     * @param bo 查询条件
     * @return 小区基础信息;列表
     */
    @Override
    public List<EHouseInfoVo> queryList(EHouseInfoBo bo) {
        LambdaQueryWrapper<EHouseInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<EHouseInfo> buildQueryWrapper(EHouseInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<EHouseInfo> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getOrganizationId()), EHouseInfo::getOrganizationId, bo.getOrganizationId());
        lqw.eq(StringUtils.isNotBlank(bo.getCode()), EHouseInfo::getCode, bo.getCode());
        lqw.like(StringUtils.isNotBlank(bo.getName()), EHouseInfo::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), EHouseInfo::getAddress, bo.getAddress());
        lqw.eq(StringUtils.isNotBlank(bo.getAreaCode()), EHouseInfo::getAreaCode, bo.getAreaCode());
        lqw.orderByDesc(EHouseInfo::getCreateTime);
        return lqw;
    }

    /**
     * 新增小区基础信息;
     *
     * @param bo 小区基础信息;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(EHouseInfoBo bo) {
        EHouseInfo add = MapstructUtils.convert(bo, EHouseInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改小区基础信息;
     *
     * @param bo 小区基础信息;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(EHouseInfoBo bo) {
        EHouseInfo update = MapstructUtils.convert(bo, EHouseInfo.class);
        validEntityBeforeUpdate(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(EHouseInfo entity){
        //TODO 做一些数据校验,如唯一约束
        LambdaQueryWrapper<EHouseInfo> num = Wrappers.lambdaQuery();
        num.eq(StringUtils.isNotBlank(entity.getCode()), EHouseInfo::getCode, entity.getCode());
        List<EHouseInfoVo> infoVoList = baseMapper.selectVoList(num);
        if (!infoVoList.isEmpty()) {
            throw new ServiceException("该小区编号已存在!");
        }
    }

    /**
     * 更新前的数据校验
     */
    private void validEntityBeforeUpdate(EHouseInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }


    /**
     * 校验并批量删除小区基础信息;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }

    @Override
    public EHouseInfoVo selectByCode(String code) {
        return baseMapper.selectVoOne(new LambdaQueryWrapper<EHouseInfo>().eq(EHouseInfo::getCode, code));
    }
}
